
#include <cmath>
#include <cstdlib>

//#include <cstdio>
#include <iostream>
//#include <vector>
using namespace std;

#include <vector_types.h>		// cuda 
#include "ballscpu.h"
#include "ballscuda.h"


#define pos pos_host
#define vel vel_host
#define mas mas_host
#define R R_host
#define forc forc_host

const float C = 1.5;
float KFG = 250.0;
const float bkr = 1400;
const float bkd = 10;

extern int selected_ball_i;



void initparticles(void)
{
	float x,y,m,r,vx,vy;
	int i=0;

	const float r0 = 0.025;
	const float dr = 0;//0.055;
	const float m0 = 1.75;
	const float dm = 0;//0.25;

	for(int k=1; k<N; k++)
	{
		i++;
		float size = rand()/float(RAND_MAX);
		
		x = 2*(rand()/float(RAND_MAX)-0.5);
		y = 2*(rand()/float(RAND_MAX)-0.5);
		
		vx = 2*(rand()/float(RAND_MAX)-0.5);
		vy = 2*(rand()/float(RAND_MAX)-0.5);


		r = r0 + dr * size;
		m = m0 + dm * size*size*size;
		
		pos[k].x = x;
		pos[k].y = y;
		pos[k].z = 0;
		

		vel[k].x = vx;
		vel[k].y = vy;
		
		mas[k] = m;
		R[k] = r;
	}

	pos[0].x = 0;
	pos[0].y = 0;
	vel[0].x = 0;
	vel[0].y = 0;
	mas[0] = 10.0;
	R[0] = 0.20;
}


#define pos pos_host
#define vel vel_host
#define mas mas_host
#define forc forc_host

void initparticles2(void)
{
	float x,y,m,vx,vy;

	const float maxmass = 0.3f;
	const float iv = 0.5f;
		int i=0;



#define CONFIG 0

	switch(CONFIG)
	{
		case 0:
			for(i=0; i < N; i++)
			{
				x = 2*(rand()/float(RAND_MAX)-0.5f);
				y = 2*(rand()/float(RAND_MAX)-0.5f);

				m = maxmass*(rand()/float(RAND_MAX));

				vx = 0;//iv*(rand()/float(RAND_MAX)-0.5f);
				vy = 0;//iv*(rand()/float(RAND_MAX)-0.5f);

				pos[i].x = x;
				pos[i].y = y;
				pos[i].z = 0;
				

				vel[i].x = vx;
				vel[i].y = vy;
				vel[i].z = 0;
				
				mas[i] = 1.75;
				R[i] = 0.025;
			}
		break;

		case 1:


			//for(int i=0; i < N; i++)
			for(x=-0.25; x<0.25; x+=0.01)
			for(y=-0.25; y<0.25; y+=0.01)
			if(sqrt(x*x+y*y) <0.25)
			{
				if(i>N)	break;

				m = maxmass*(rand()/float(RAND_MAX));

				vx = iv*(rand()/float(RAND_MAX)-0.5f);
				vy = iv*(rand()/float(RAND_MAX)-0.5f);

				pos[i].x = x+0.5;
				pos[i].y = y+0.5;


				vel[i].x = vx;
				vel[i].y = vy;
				
				mas[i] = m;
				i++;
			}


			for(x=-0.25; x<0.25; x+=0.01)
			for(y=-0.25; y<0.25; y+=0.01)
			if(sqrt(x*x+y*y) <0.25)
			{
				if(i>N)	break;

				m = maxmass*(rand()/float(RAND_MAX));

				vx = iv*(rand()/float(RAND_MAX)-0.5f);
				vy = iv*(rand()/float(RAND_MAX)-0.5f);

				pos[i].x = x-0.5;
				pos[i].y = y-0.5;


				vel[i].x = vx;
				vel[i].y = vy;
				
				mas[i] = m;
				i++;
			}

			for(x=-0.25; x<0.25; x+=0.01)
			for(y=-0.25; y<0.25; y+=0.01)
			if(sqrt(x*x+y*y) <0.25)
			{
				if(i>N)	break;

		
				m = maxmass*(rand()/float(RAND_MAX));

				vx = iv*(rand()/float(RAND_MAX)-0.5f);
				vy = iv*(rand()/float(RAND_MAX)-0.5f);

				pos[i].x = x+0.5;
				pos[i].y = y-0.5;


				vel[i].x = vx;
				vel[i].y = vy;
				
				mas[i] = m;
				i++;
			}
			break;

	}

	cout << "particles: " << i << endl;
}



void moveparticles(float dt, float3 G, FLOATVEC _ATTRACT)
{
	float dtm,v;
	float ksi, dksidt, fn;
	float nx,ny,nz,vx,vy,vz;

	for(int i=0; i<N; i++)
		forc[i].x = forc[i].y = forc[i].z = 0;

	// gravity
	for(int i=0; i<N; i++)
	{
		forc[i].x = forc[i].x + mas[i]*G.x;
		forc[i].y = forc[i].y + mas[i]*G.y;
		forc[i].z = forc[i].z + mas[i]*G.z;
	}

	// collision walls
	for(int i=0; i<N; i++)
 	{
		if (pos[i].y - R[i] < -0.95)	forc[i].y = forc[i].y - KFG * (pos[i].y - R[i] - (-0.95));
		if (pos[i].x - R[i] < -1.0)		forc[i].x = forc[i].x - KFG * (pos[i].x - R[i] - (-1.0));
		if (pos[i].x + R[i] >  1.0)		forc[i].x = forc[i].x - KFG * (pos[i].x + R[i] - 1.0);
	}

	// collisions ball / ball

	float dist,oneoverdist;

	for(int i=0;	i<N;	i++)
//	for(int j=i+1;	j<N;	j++)
	for(int j=0;	j<N;	j++)
	if(i!=j)
	{
		dist = sqrt((pos[j].x - pos[i].x)*(pos[j].x - pos[i].x) + 
					(pos[j].y - pos[i].y)*(pos[j].y - pos[i].y) + 
					(pos[j].z - pos[i].z)*(pos[j].z - pos[i].z));


		ksi =  (R[i] + R[j]) - dist;

		if ( ksi > 0 )
		{
			oneoverdist = 1.0f/dist;

			//Bell et.al., 'Particle-based simulation of granular materials', equations 1-8, p. 3.

			nx = (pos[j].x - pos[i].x) * (oneoverdist);
			ny = (pos[j].y - pos[i].y) * (oneoverdist);
			nz = (pos[j].z - pos[i].z) * (oneoverdist);

			vx = vel[i].x - vel[j].x;
			vy = vel[i].y - vel[j].y;
			vz = vel[i].z - vel[j].z;

			dksidt = vx * nx + vy * ny + vz * nz;

			fn = - bkr * ksi - bkd * dksidt;

			forc[i].x = forc[i].x + fn * nx;
			forc[i].y = forc[i].y + fn * ny;
			forc[i].z = forc[i].z + fn * nz;

			/*forc[j].x = forc[j].x - fn * nx;
			forc[j].y = forc[j].y - fn * ny;
			forc[j].z = forc[j].z - fn * nz;*/

		}

	}

	// damp
	for(int i=0; i<N; i++)
	if(i != selected_ball_i)
	{
		v = sqrt(vel[i].x * vel[i].x + vel[i].y * vel[i].y + vel[i].z * vel[i].z);

		if(v)
		{
			forc[i].x = forc[i].x - 2*R[i] * v * vel[i].x * (1.0/v) * C;
			forc[i].y = forc[i].y - 2*R[i] * v * vel[i].y * (1.0/v) * C;
		}

		dtm = dt / mas[i];

		vel[i].x = vel[i].x + ( dtm ) * forc[i].x;
		vel[i].y = vel[i].y + ( dtm ) * forc[i].y;

		pos[i].x = pos[i].x + dt * vel[i].x;
		pos[i].y = pos[i].y + dt * vel[i].y;
	}


}


